Index: /trunk/sources/HeuristicLab.Core.Views/3.3/TypeSelector.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/TypeSelector.Designer.cs	(revision 2655)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/TypeSelector.Designer.cs	(revision 2655)
@@ -0,0 +1,148 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Core.Views {
+  partial class TypeSelector {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing) {
+        if (components != null) components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.components = new System.ComponentModel.Container();
+      this.typesTreeView = new System.Windows.Forms.TreeView();
+      this.imageList = new System.Windows.Forms.ImageList(this.components);
+      this.groupBox = new System.Windows.Forms.GroupBox();
+      this.splitContainer = new System.Windows.Forms.SplitContainer();
+      this.descriptionTextBox = new System.Windows.Forms.TextBox();
+      this.groupBox.SuspendLayout();
+      this.splitContainer.Panel1.SuspendLayout();
+      this.splitContainer.Panel2.SuspendLayout();
+      this.splitContainer.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // typesTreeView
+      // 
+      this.typesTreeView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.typesTreeView.HideSelection = false;
+      this.typesTreeView.ImageIndex = 0;
+      this.typesTreeView.ImageList = this.imageList;
+      this.typesTreeView.Location = new System.Drawing.Point(0, 0);
+      this.typesTreeView.Name = "typesTreeView";
+      this.typesTreeView.SelectedImageIndex = 0;
+      this.typesTreeView.ShowNodeToolTips = true;
+      this.typesTreeView.Size = new System.Drawing.Size(297, 199);
+      this.typesTreeView.TabIndex = 0;
+      this.typesTreeView.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.typesTreeView_AfterSelect);
+      this.typesTreeView.ItemDrag += new System.Windows.Forms.ItemDragEventHandler(this.typesTreeView_ItemDrag);
+      // 
+      // imageList
+      // 
+      this.imageList.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
+      this.imageList.ImageSize = new System.Drawing.Size(16, 16);
+      this.imageList.TransparentColor = System.Drawing.Color.Transparent;
+      // 
+      // groupBox
+      // 
+      this.groupBox.Controls.Add(this.splitContainer);
+      this.groupBox.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.groupBox.Location = new System.Drawing.Point(0, 0);
+      this.groupBox.Name = "groupBox";
+      this.groupBox.Size = new System.Drawing.Size(303, 306);
+      this.groupBox.TabIndex = 0;
+      this.groupBox.TabStop = false;
+      this.groupBox.Text = "&Available Types";
+      // 
+      // splitContainer
+      // 
+      this.splitContainer.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.splitContainer.Location = new System.Drawing.Point(3, 16);
+      this.splitContainer.Name = "splitContainer";
+      this.splitContainer.Orientation = System.Windows.Forms.Orientation.Horizontal;
+      // 
+      // splitContainer.Panel1
+      // 
+      this.splitContainer.Panel1.Controls.Add(this.typesTreeView);
+      // 
+      // splitContainer.Panel2
+      // 
+      this.splitContainer.Panel2.Controls.Add(this.descriptionTextBox);
+      this.splitContainer.Size = new System.Drawing.Size(297, 287);
+      this.splitContainer.SplitterDistance = 199;
+      this.splitContainer.TabIndex = 2;
+      // 
+      // descriptionTextBox
+      // 
+      this.descriptionTextBox.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.descriptionTextBox.Font = new System.Drawing.Font("Courier New", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
+      this.descriptionTextBox.Location = new System.Drawing.Point(0, 0);
+      this.descriptionTextBox.Multiline = true;
+      this.descriptionTextBox.Name = "descriptionTextBox";
+      this.descriptionTextBox.ReadOnly = true;
+      this.descriptionTextBox.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
+      this.descriptionTextBox.Size = new System.Drawing.Size(297, 84);
+      this.descriptionTextBox.TabIndex = 0;
+      // 
+      // TypeSelector
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.groupBox);
+      this.Name = "TypeSelector";
+      this.Size = new System.Drawing.Size(303, 306);
+      this.groupBox.ResumeLayout(false);
+      this.splitContainer.Panel1.ResumeLayout(false);
+      this.splitContainer.Panel2.ResumeLayout(false);
+      this.splitContainer.Panel2.PerformLayout();
+      this.splitContainer.ResumeLayout(false);
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.GroupBox groupBox;
+    private System.Windows.Forms.TextBox descriptionTextBox;
+    private System.Windows.Forms.ImageList imageList;
+    private System.Windows.Forms.TreeView typesTreeView;
+    private System.Windows.Forms.SplitContainer splitContainer;
+
+
+
+  }
+}
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/TypeSelector.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/TypeSelector.cs	(revision 2655)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/TypeSelector.cs	(revision 2655)
@@ -0,0 +1,210 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Text;
+using System.Windows.Forms;
+using System.Linq;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Core.Views { 
+  public partial class TypeSelector : UserControl {
+    private Type baseType;
+    public Type BaseType {
+      get { return baseType; }
+    }
+    private bool showNotInstantiableTypes;
+    public bool ShowNotInstantiableTypes {
+      get { return showNotInstantiableTypes; }
+    }
+    private bool showGenericTypes;
+    public bool ShowGenericTypes {
+      get { return showGenericTypes; }
+    }
+    public string Caption {
+      get { return groupBox.Text; }
+      set {
+        if (InvokeRequired)
+          Invoke(new Action<string>(delegate(string s) { Caption = s; }), value);
+        else
+          groupBox.Text = value;
+      }
+    }
+    public TreeView TypesTreeView {
+      get { return typesTreeView; }
+    }
+    private Type selectedType;
+    public Type SelectedType {
+      get { return selectedType; }
+      private set {
+        if (value != selectedType) {
+          selectedType = value;
+          OnSelectedTypeChanged();
+        }
+      }
+    }
+
+    public TypeSelector() {
+      InitializeComponent();
+      selectedType = null;
+    }
+
+    public void Configure(Type baseType, bool showNotInstantiableTypes, bool showGenericTypes) {
+      if (baseType == null) throw new ArgumentNullException();
+      if (InvokeRequired)
+        Invoke(new Action<Type, bool, bool>(Configure), baseType, showNotInstantiableTypes, showGenericTypes);
+      else {
+        this.baseType = baseType;
+        this.showNotInstantiableTypes = showNotInstantiableTypes;
+        this.showGenericTypes = showGenericTypes;
+
+        typesTreeView.Nodes.Clear();
+        imageList.Images.Clear();
+        imageList.Images.Add(HeuristicLab.Common.Resources.VS2008ImageLibrary.Class);      // default icon
+        imageList.Images.Add(HeuristicLab.Common.Resources.VS2008ImageLibrary.Namespace);  // plugins
+        imageList.Images.Add(HeuristicLab.Common.Resources.VS2008ImageLibrary.Interface);  // interfaces
+        imageList.Images.Add(HeuristicLab.Common.Resources.VS2008ImageLibrary.OrgChart);   // abstract types
+        imageList.Images.Add(HeuristicLab.Common.Resources.VS2008ImageLibrary.Template);   // generic types
+
+        TreeNode selectedNode = null;
+        var plugins = from p in ApplicationManager.Manager.Plugins
+                      orderby p.Name, p.Version ascending
+                      select p;
+        foreach (IPluginDescription plugin in plugins) {
+          TreeNode pluginNode = new TreeNode();
+          pluginNode.Text = plugin.Name;
+          pluginNode.ImageIndex = 1;
+          pluginNode.SelectedImageIndex = pluginNode.ImageIndex;
+          pluginNode.Tag = plugin;
+
+          var types = from t in ApplicationManager.Manager.GetTypes(BaseType, plugin, false)
+                      orderby t.Name ascending
+                      select t;
+          foreach (Type type in types) {
+            bool valid = true;
+            valid = valid && (ShowGenericTypes || !type.ContainsGenericParameters);
+            valid = valid && (ShowNotInstantiableTypes || !type.IsAbstract);
+            valid = valid && (ShowNotInstantiableTypes || !type.IsInterface);
+            valid = valid && (ShowNotInstantiableTypes || !type.HasElementType);
+            if (valid) {
+              TreeNode typeNode = new TreeNode();
+              string name = ItemAttribute.GetName(type);
+              typeNode.Text = name != null ? name : type.Name;
+              typeNode.ImageIndex = 0;
+              if (type.IsInterface) typeNode.ImageIndex = 2;
+              else if (type.IsAbstract) typeNode.ImageIndex = 3;
+              else if (type.ContainsGenericParameters) typeNode.ImageIndex = 4;
+              else if (imageList.Images.ContainsKey(type.FullName)) typeNode.ImageIndex = imageList.Images.IndexOfKey(type.FullName);
+              else if (typeof(IItem).IsAssignableFrom(type)) {
+                try {
+                  IItem item = (IItem)Activator.CreateInstance(type);
+                  imageList.Images.Add(type.FullName, item.ItemImage);
+                  typeNode.ImageIndex = imageList.Images.IndexOfKey(type.FullName);
+                }
+                catch (Exception) {
+                }
+              }
+              typeNode.SelectedImageIndex = typeNode.ImageIndex;
+              typeNode.Tag = type;
+              if (type == SelectedType) selectedNode = typeNode;
+              pluginNode.Nodes.Add(typeNode);
+            }
+          }
+          if (pluginNode.Nodes.Count > 0)
+            typesTreeView.Nodes.Add(pluginNode);
+        }
+        if (typesTreeView.Nodes.Count == 0) {
+          typesTreeView.Nodes.Add("No types of base type \"" + BaseType.Name + "\" found");
+          typesTreeView.Enabled = false;
+        }
+        if (selectedNode != null) {
+          typesTreeView.SelectedNode = selectedNode;
+          selectedNode.EnsureVisible();
+        } else {
+          SelectedType = null;
+        }
+      }
+    }
+
+    public object CreateInstanceOfSelectedType(params object[] args) {
+      if (SelectedType != null) {
+      try {
+        return Activator.CreateInstance(SelectedType, args);
+      } catch(Exception) { }
+      }
+      return null;
+    }
+
+    public event EventHandler SelectedTypeChanged;
+    protected virtual void OnSelectedTypeChanged() {
+      if (SelectedTypeChanged != null)
+        SelectedTypeChanged(this, EventArgs.Empty);
+    }
+
+    private void UpdateDescription() {
+      descriptionTextBox.Text = string.Empty;
+
+      if (typesTreeView.SelectedNode != null) {
+        IPluginDescription plugin = typesTreeView.SelectedNode.Tag as IPluginDescription;
+        if (plugin != null) {
+          StringBuilder sb = new StringBuilder();
+          sb.Append("Plugin: ").Append(plugin.Name).Append(Environment.NewLine);
+          sb.Append("Version: ").Append(plugin.Version.ToString()).Append(Environment.NewLine);
+          sb.Append("Build Date: ").Append(plugin.BuildDate.ToString());
+          descriptionTextBox.Text = sb.ToString();
+        }
+        Type type = typesTreeView.SelectedNode.Tag as Type;
+        if (type != null) {
+          string description = ItemAttribute.GetDescription(type);
+          if (description != null)
+            descriptionTextBox.Text = description;
+        }
+      }
+    }
+
+    private void typesTreeView_AfterSelect(object sender, TreeViewEventArgs e) {
+      if (typesTreeView.SelectedNode != null) {
+        SelectedType = typesTreeView.SelectedNode.Tag as Type;
+      }
+      UpdateDescription();
+    }
+
+    private void typesTreeView_ItemDrag(object sender, ItemDragEventArgs e) {
+      TreeNode node = (TreeNode)e.Item;
+      Type type = node.Tag as Type;
+      if (type != null) {
+        try {
+          object o = Activator.CreateInstance(type);
+          DataObject data = new DataObject();
+          data.SetData("Type", type);
+          data.SetData("Value", o);
+          DoDragDrop(data, DragDropEffects.Link);
+        } catch (Exception) {
+        }
+      }
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/TypeSelectorDialog.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/TypeSelectorDialog.Designer.cs	(revision 2655)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/TypeSelectorDialog.Designer.cs	(revision 2655)
@@ -0,0 +1,111 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Core.Views {
+  partial class TypeSelectorDialog {
+    /// <summary>
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary>
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) components.Dispose();
+      base.Dispose(disposing);
+    }
+
+    #region Windows Form Designer generated code
+
+    /// <summary>
+    /// Required method for Designer support - do not modify
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.okButton = new System.Windows.Forms.Button();
+      this.cancelButton = new System.Windows.Forms.Button();
+      this.typeSelector = new HeuristicLab.Core.Views.TypeSelector();
+      this.SuspendLayout();
+      // 
+      // okButton
+      // 
+      this.okButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.okButton.DialogResult = System.Windows.Forms.DialogResult.OK;
+      this.okButton.Location = new System.Drawing.Point(305, 368);
+      this.okButton.Name = "okButton";
+      this.okButton.Size = new System.Drawing.Size(75, 23);
+      this.okButton.TabIndex = 1;
+      this.okButton.Text = "&OK";
+      this.okButton.UseVisualStyleBackColor = true;
+      // 
+      // cancelButton
+      // 
+      this.cancelButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.cancelButton.DialogResult = System.Windows.Forms.DialogResult.Cancel;
+      this.cancelButton.Location = new System.Drawing.Point(386, 368);
+      this.cancelButton.Name = "cancelButton";
+      this.cancelButton.Size = new System.Drawing.Size(75, 23);
+      this.cancelButton.TabIndex = 2;
+      this.cancelButton.Text = "&Cancel";
+      this.cancelButton.UseVisualStyleBackColor = true;
+      // 
+      // typeSelector
+      // 
+      this.typeSelector.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.typeSelector.Location = new System.Drawing.Point(12, 12);
+      this.typeSelector.Name = "typeSelector";
+      this.typeSelector.Size = new System.Drawing.Size(449, 350);
+      this.typeSelector.TabIndex = 3;
+      this.typeSelector.SelectedTypeChanged += new System.EventHandler(this.typeSelector_SelectedTypeChanged);
+      this.typeSelector.TypesTreeView.DoubleClick += new System.EventHandler(TypesTreeView_DoubleClick);
+      // 
+      // TypeSelectorDialog
+      // 
+      this.AcceptButton = this.okButton;
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.CancelButton = this.cancelButton;
+      this.ClientSize = new System.Drawing.Size(473, 403);
+      this.Controls.Add(this.typeSelector);
+      this.Controls.Add(this.cancelButton);
+      this.Controls.Add(this.okButton);
+      this.MaximizeBox = false;
+      this.MinimizeBox = false;
+      this.Name = "TypeSelectorDialog";
+      this.ShowIcon = false;
+      this.ShowInTaskbar = false;
+      this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
+      this.Text = "Select Type";
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Button okButton;
+    private System.Windows.Forms.Button cancelButton;
+    private TypeSelector typeSelector;
+  }
+}
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/TypeSelectorDialog.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/TypeSelectorDialog.cs	(revision 2655)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/TypeSelectorDialog.cs	(revision 2655)
@@ -0,0 +1,72 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Core.Views {
+  /// <summary>
+  /// A dialog to select a specific type.
+  /// </summary>
+  public partial class TypeSelectorDialog : Form {
+    /// <summary>
+    /// Gets or sets the caption of the dialog.
+    /// </summary>
+    /// <remarks>Uses property <see cref="Form.Text"/> of base class <see cref="Form"/>.
+    /// No own data storage present.</remarks>
+    public string Caption {
+      get { return Text; }
+      set {
+        if (InvokeRequired)
+          Invoke(new Action<string>(delegate(string s) { Caption = s; }), value);
+        else
+          Text = value;
+      }
+    }
+    public TypeSelector TypeSelector {
+      get { return typeSelector; }
+    }
+
+    /// <summary>
+    /// Initializes a new instance of <see cref="ChooseTypeDialog"/>.
+    /// </summary>
+    public TypeSelectorDialog() {
+      InitializeComponent();
+    }
+
+    private void typeSelector_SelectedTypeChanged(object sender, EventArgs e) {
+      okButton.Enabled = typeSelector.SelectedType != null;
+    }
+    private void TypesTreeView_DoubleClick(object sender, System.EventArgs e) {
+      if (typeSelector.SelectedType != null) {
+        DialogResult = DialogResult.OK;
+        Close();
+      }
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/VariableCollectionView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/VariableCollectionView.Designer.cs	(revision 2655)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/VariableCollectionView.Designer.cs	(revision 2655)
@@ -0,0 +1,32 @@
+﻿namespace HeuristicLab.Core.Views {
+  partial class VariableCollectionView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing) {
+        if (components != null) components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      components = new System.ComponentModel.Container();
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+    }
+
+    #endregion
+  }
+}
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/VariableCollectionView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/VariableCollectionView.cs	(revision 2655)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/VariableCollectionView.cs	(revision 2655)
@@ -0,0 +1,35 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.MainForm;
+using HeuristicLab.Collections;
+
+namespace HeuristicLab.Core.Views {
+  [Content(typeof(VariableCollection), true)]
+  [Content(typeof(IObservableKeyedCollection<string, Variable>), true)]
+  public partial class VariableCollectionView : NamedItemCollectionView<Variable> {
+    /// <summary>
+    /// Initializes a new instance of <see cref="VariablesScopeView"/> with caption "Variables Scope View".
+    /// </summary>
+    public VariableCollectionView() {
+      InitializeComponent();
+      Caption = "VariableCollection";
+      itemsGroupBox.Text = "&Variables";
+    }
+    /// <summary>
+    /// Initializes a new instance of <see cref="VariablesScopeView"/> with 
+    /// the given <paramref name="scope"/>.
+    /// </summary>
+    /// <remarks>Calls <see cref="VariablesScopeView()"/>.</remarks>
+    /// <param name="scope">The scope whose variables should be represented visually.</param>
+    public VariableCollectionView(IObservableKeyedCollection<string, Variable> variableCollection)
+      : this() {
+      NamedItemCollection = variableCollection;
+    }
+  }
+}
